//
//  Sample.m

#import "Sample.h"
#import "Constants.h"

enum {
	MKLimitNone = 0,
	MKLimitTitle,
	MKLimitIMDb
};

@implementation Sample


#pragma mark -
#pragma mark Menu Command

- (id)init {
    self = [super init];
    if (self) {
		NSMenuItem *aMenuItem = [[[NSMenuItem alloc] init] autorelease];
		[aMenuItem setTitle:@"Export XMBC"];
		[aMenuItem setTarget:self];
		[aMenuItem setAction:@selector(exportXBMC:)];
		
//		NSMenuItem *secondMenuItem = [[[NSMenuItem alloc] init] autorelease];
//		[secondMenuItem setTitle:@"A Second Menu"];
//		[secondMenuItem setTarget:self];
//		[secondMenuItem setAction:@selector(doSecondTest:)];

		
        MyPluginManager *pluginManager = [(MyControllerForPlugins *)[NSApp delegate] pluginManager];
        [pluginManager addMenuItem:aMenuItem menuTitle:nil];
//		[pluginManager addMenuItem:secondMenuItem];
//		[pluginManager addMenuItem:[NSMenuItem separatorItem]];				
	}
	return self;
}


- (IBAction)exportXBMC:(id)sender {
    MyControllerForPlugins *controller = (MyControllerForPlugins *)[NSApp delegate];
    
    // Load the XMBC template from the data folder
    NSString *pathToTempalte = [NSString stringWithFormat:@"%@/Templates/XBMC.nfo", [controller dataFolderPath]];
    NSString *templateStructure = [[[NSString alloc] initWithContentsOfFile:pathToTempalte encoding:NSUTF8StringEncoding error:NULL] autorelease];
    if (templateStructure == nil) {
        MyLog(@"Error: loading XMBC template, not found at: %@", pathToTempalte);
    }
    
    
    NSArray *selection = [controller selectedEntries];
    for (MOEntry *movie in selection) {
        NSMutableSet *linksSet = [movie mutableSetValueForKey:@"linksSet"];
        for (MOLink *aLink in linksSet) {
            NSString *path = [controller normalizeLinkedFiledPath:[aLink valueForKey:@"url"]];
            if ([MOLink isPathMovieLink:path]) {
                
                // We have a movie file path.
                NSString *parentFolder = [path stringByDeletingLastPathComponent];
                
                // Create a copy of the template and fill it out with the movie info, save it to disk
                NSMutableString *templateFile = [[templateStructure mutableCopy] autorelease];
                [controller replaceKeysInTemplate:templateFile forEntry:movie html:NO webView:NO];
                
                NSString *title = [movie valueForKey:@"title"];
                NSString *nfoPath = [parentFolder stringByAppendingFormat:@"/%@.nfo", title];
                [templateFile writeToFile:nfoPath atomically:YES encoding:NSUTF8StringEncoding error:nil];
                
                //Now place cover as well
                NSString *coverPath = [parentFolder stringByAppendingFormat:@"/%@.tbn", title];
                [[NSFileManager defaultManager] copyItemAtPath:movie.coverImagePath toPath:coverPath error:nil];
            }
        }
    }
}
 

//- (IBAction)doSecondTest:(id)sender {
//	NSLog(@"Doing another Test");
//}

@end
